getTypeDistributions <- function() {
  
  nonRefactorables <- joinedNicad[joinedNicad$X.NodeComparisons > 0 & joinedNicad$X.RefactorableSubtrees == 0 & joinedNicad$average >= 1 & joinedNicad$average < 4, ]
  
  cat (paste("1 = ", length(nonRefactorables$GroupID[nonRefactorables$CloneType == 1]) / length(nonRefactorables$GroupID)), "\n" )
  cat (paste("2 = ", length(nonRefactorables$GroupID[nonRefactorables$CloneType == 2]) / length(nonRefactorables$GroupID)), "\n" )
  cat (paste("3 = ", length(nonRefactorables$GroupID[nonRefactorables$CloneType == 3]) / length(nonRefactorables$GroupID)), "\n" )
  cat (paste("Unknown = ", length(nonRefactorables$GroupID[nonRefactorables$CloneType == 4]) / length(nonRefactorables$GroupID) ), "\n" )

}


plotTypeDistributionsForNicad <- function() {
  
  library(Hmisc, lattice)
  
  nonRefactorables <- joinedNicad[joinedNicad$X.NodeComparisons > 0 & joinedNicad$X.RefactorableSubtrees == 0,  ]
  for (i in 1:4) {
    print(paste("Type", i, " median = ", median(nonRefactorables$average[nonRefactorables$CloneType == i])))
    print(paste("Type", i, " mean = ", mean(nonRefactorables$average[nonRefactorables$CloneType == i])))
  }
  
  bwplot(log10(nonRefactorables$average) ~ factor(nonRefactorables$CloneType),  
         panel = function(..., box.ratio) {
           panel.violin(..., col = "#cccccc", border="#777777", 
                        varwidth = FALSE, box.ratio = box.ratio, box.width=0.8)
           panel.bwplot(..., fill = "transparent", box.width=0.3, pch='|')
         }
  )
}